"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

var _COLORS = require("./COLORS");

// 把一些错认为名词的词标注为形容词，或者对名词作定语的情况
var AdjectiveOptimizer =
/*#__PURE__*/
function (_Optimizer) {
  (0, _inherits2.default)(AdjectiveOptimizer, _Optimizer);

  function AdjectiveOptimizer() {
    (0, _classCallCheck2.default)(this, AdjectiveOptimizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AdjectiveOptimizer).apply(this, arguments));
  }

  (0, _createClass2.default)(AdjectiveOptimizer, [{
    key: "doOptimize",
    value: function doOptimize(words) {
      var POSTAG = this.segment.POSTAG;
      var index = 0;

      while (index < words.length) {
        var word = words[index];
        var nextword = words[index + 1];

        if (nextword) {
          // 对于<颜色>+<的>，直接判断颜色是形容词（字典里颜色都是名词）
          if (nextword.p === POSTAG.D_U && _COLORS.colors.includes(word.w)) {
            word.p = POSTAG.D_A;
          } // 如果是连续的两个名词，前一个是颜色，那这个颜色也是形容词


          if (word.p === POSTAG.D_N && this.isNominal(nextword.p) && _COLORS.colors.includes(word.w)) {
            word.p = POSTAG.D_A;
          }
        } // 移到下一个单词


        index += 1;
      }

      return words;
    }
  }, {
    key: "isNominal",
    value: function isNominal(pos) {
      if (Array.isArray(pos)) {
        return this.isNominal(pos[0]);
      }

      var POSTAG = this.segment.POSTAG;
      return pos === POSTAG.D_N || pos === POSTAG.A_NT || pos === POSTAG.A_NX || pos === POSTAG.A_NZ || pos === POSTAG.A_NR || pos === POSTAG.A_NS || pos === POSTAG.URL;
    }
  }]);
  return AdjectiveOptimizer;
}(_BaseModule.Optimizer);

exports.default = AdjectiveOptimizer;