"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

var _CHS_NAMES = require("./CHS_NAMES");

var ChsNameOptimizer =
/*#__PURE__*/
function (_Optimizer) {
  (0, _inherits2.default)(ChsNameOptimizer, _Optimizer);

  function ChsNameOptimizer() {
    (0, _classCallCheck2.default)(this, ChsNameOptimizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ChsNameOptimizer).apply(this, arguments));
  }

  (0, _createClass2.default)(ChsNameOptimizer, [{
    key: "doOptimize",
    value: function doOptimize(words) {
      var POSTAG = this.segment.POSTAG;
      var i = 0;
      /* 第一遍扫描 */

      while (i < words.length) {
        var word = words[i];
        var nextword = words[i + 1];

        if (nextword) {
          // debug(nextword);
          // 如果为  "小|老" + 姓
          if (nextword && (word.w === '小' || word.w === '老') && (nextword.w in _CHS_NAMES.FAMILY_NAME_1 || nextword.w in _CHS_NAMES.FAMILY_NAME_2)) {
            words.splice(i, 2, {
              w: word.w + nextword.w,
              p: POSTAG.A_NR
            });
            i++;
            continue;
          } // 如果是 姓 + 名（2字以内）


          if ((word.w in _CHS_NAMES.FAMILY_NAME_1 || word.w in _CHS_NAMES.FAMILY_NAME_2) && (nextword.p & POSTAG.A_NR) > 0 && nextword.w.length <= 2) {
            words.splice(i, 2, {
              w: word.w + nextword.w,
              p: POSTAG.A_NR
            });
            i++;
            continue;
          } // 如果相邻两个均为单字且至少有一个字是未识别的，则尝试判断其是否为人名


          if (!word.p || !nextword.p) {
            if (word.w in _CHS_NAMES.SINGLE_NAME && word.w === nextword.w || word.w in _CHS_NAMES.DOUBLE_NAME_1 && nextword.w in _CHS_NAMES.DOUBLE_NAME_2) {
              words.splice(i, 2, {
                w: word.w + nextword.w,
                p: POSTAG.A_NR
              }); // 如果上一个单词可能是一个姓，则合并

              var preword = words[i - 1];

              if (preword && (preword.w in _CHS_NAMES.FAMILY_NAME_1 || preword.w in _CHS_NAMES.FAMILY_NAME_2)) {
                words.splice(i - 1, 2, {
                  w: preword.w + word.w + nextword.w,
                  p: POSTAG.A_NR
                });
              } else {
                i++;
              }

              continue;
            }
          } // 如果为 无歧义的姓 + 名（2字以内） 且其中一个未未识别词


          if ((word.w in _CHS_NAMES.FAMILY_NAME_1 || word.w in _CHS_NAMES.FAMILY_NAME_2) && (!word.p || !nextword.p)) {
            // debug(word, nextword);
            words.splice(i, 2, {
              w: word.w + nextword.w,
              p: POSTAG.A_NR
            });
          }
        } // 移到下一个单词


        i++;
      }
      /* 第二遍扫描 */


      i = 0;

      while (i < words.length) {
        var _word = words[i];
        var _nextword = words[i + 1];

        if (_nextword) {
          // 如果为 姓 + 单字名
          if ((_word.w in _CHS_NAMES.FAMILY_NAME_1 || _word.w in _CHS_NAMES.FAMILY_NAME_2) && _nextword.w in _CHS_NAMES.SINGLE_NAME) {
            words.splice(i, 2, {
              w: _word.w + _nextword.w,
              p: POSTAG.A_NR
            });
            i++;
            continue;
          }
        } // 移到下一个单词


        i++;
      }

      return words;
    }
  }]);
  return ChsNameOptimizer;
}(_BaseModule.Optimizer);

exports.default = ChsNameOptimizer;