"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

var _CHS_NAMES = require("./CHS_NAMES");

var ChsNameTokenizer =
/*#__PURE__*/
function (_Tokenizer) {
  (0, _inherits2.default)(ChsNameTokenizer, _Tokenizer);

  function ChsNameTokenizer() {
    (0, _classCallCheck2.default)(this, ChsNameTokenizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ChsNameTokenizer).apply(this, arguments));
  }

  (0, _createClass2.default)(ChsNameTokenizer, [{
    key: "split",
    value: function split(words) {
      var POSTAG = this.segment.POSTAG;
      var ret = [];

      for (var i = 0, word; word = words[i]; i++) {
        if (word.p > 0) {
          ret.push(word);
          continue;
        } // 仅对未识别的词进行匹配


        var nameinfo = ChsNameTokenizer.matchName(word.w);

        if (nameinfo.length < 1) {
          ret.push(word);
          continue;
        } // 分离出人名


        var lastc = 0;

        for (var ui = 0, url; url = nameinfo[ui]; ui++) {
          if (url.c > lastc) {
            ret.push({
              w: word.w.substr(lastc, url.c - lastc)
            });
          }

          ret.push({
            w: url.w,
            p: POSTAG.A_NR
          });
          lastc = url.c + url.w.length;
        }

        var lastn = nameinfo[nameinfo.length - 1];

        if (lastn.c + lastn.w.length < word.w.length) {
          ret.push({
            w: word.w.substr(lastn.c + lastn.w.length)
          });
        }
      }

      return ret;
    } // 匹配包含的人名，并返回相关信息

  }], [{
    key: "matchName",
    value: function matchName(text, startPos) {
      var startPosition = 0;
      if (!isNaN(startPos)) startPosition = startPos;
      var result = [];

      while (startPosition < text.length) {
        var name = false; // 取两个字，看看在不在复姓表里

        var f2 = text.substr(startPosition, 2);

        if (f2 in _CHS_NAMES.FAMILY_NAME_2) {
          var n1 = text.charAt(startPosition + 2);
          var n2 = text.charAt(startPosition + 3); // 看看姓后面的字在不在名表里

          if (n1 in _CHS_NAMES.DOUBLE_NAME_1 && n2 in _CHS_NAMES.DOUBLE_NAME_2) {
            name = f2 + n1 + n2;
          } else if (n1 in _CHS_NAMES.SINGLE_NAME) {
            name = f2 + n1 + (n1 === n2 ? n2 : '');
          }
        } // 单姓


        var f1 = text.charAt(startPosition);

        if (name === false && f1 in _CHS_NAMES.FAMILY_NAME_1) {
          var _n = text.charAt(startPosition + 1);

          var _n2 = text.charAt(startPosition + 2);

          if (_n in _CHS_NAMES.DOUBLE_NAME_1 && _n2 in _CHS_NAMES.DOUBLE_NAME_2) {
            name = f1 + _n + _n2;
          } else if (_n in _CHS_NAMES.SINGLE_NAME) {
            name = f1 + _n + (_n === _n2 ? _n2 : '');
          }
        } // 检查是否匹配成功


        if (name === false) {
          startPosition++;
        } else {
          result.push({
            w: name,
            c: startPosition
          });
          startPosition += name.length;
        }
      }

      return result;
    }
  }]);
  return ChsNameTokenizer;
}(_BaseModule.Tokenizer);

exports.default = ChsNameTokenizer;