"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

// 日期时间常见组合
var DATETIME_WORDS = ['世纪', '年', '年份', '年度', '月', '月份', '月度', '日', '号', '时', '点', '点钟', '分', '分钟', '秒', '毫秒'];
var DATETIME = {}; // eslint-disable-next-line

for (var i in DATETIME_WORDS) {
  DATETIME[DATETIME_WORDS[i]] = DATETIME_WORDS[i].length;
}

var DatetimeOptimizer =
/*#__PURE__*/
function (_Optimizer) {
  (0, _inherits2.default)(DatetimeOptimizer, _Optimizer);

  function DatetimeOptimizer() {
    (0, _classCallCheck2.default)(this, DatetimeOptimizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(DatetimeOptimizer).apply(this, arguments));
  }

  (0, _createClass2.default)(DatetimeOptimizer, [{
    key: "doOptimize",

    /**
     * 日期时间优化
     *
     * @param {array} words 单词数组
     * @param {bool} isNotFirst 是否为管理器调用的
     * @return {array}
     */
    value: function doOptimize(words, isNotFirst) {
      if (typeof isNotFirst === 'undefined') {
        isNotFirst = false;
      } // 合并相邻的能组成一个单词的两个词


      var TABLE = this.segment.getDict('TABLE');
      var POSTAG = this.segment.POSTAG;
      var i = 0;
      var ie = words.length - 1;

      while (i < ie) {
        var w1 = words[i];
        var w2 = words[i + 1]; // debug(w1.w + ', ' + w2.w);

        if ((w1.p & POSTAG.A_M) > 0) {
          // =========================================
          // 日期时间组合   数字 + 日期单位，如 “2005年"
          if (w2.w in DATETIME) {
            var nw = w1.w + w2.w;
            var len = 2; // 继续搜索后面连续的日期时间描述，必须符合  数字 + 日期单位

            while (true) {
              var w1 = words[i + len];
              var w2 = words[i + len + 1];

              if (w1 && w2 && (w1.p & POSTAG.A_M) > 0 && w2.w in DATETIME) {
                len += 2;
                nw += w1.w + w2.w;
              } else {
                break;
              }
            }

            words.splice(i, len, {
              w: nw,
              p: POSTAG.D_T
            });
            ie -= len - 1;
            continue;
          } // =========================================

        } // 移到下一个词


        i++;
      }

      return words;
    }
  }]);
  return DatetimeOptimizer;
}(_BaseModule.Optimizer);

exports.default = DatetimeOptimizer;