"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

// 标点符号
var _STOPWORD = ' ,.;+-|/\\\'":?<>[]{}=!@#$%^&*()~`' + '。，、＇：∶；?‘’“”〝〞ˆˇ﹕︰﹔﹖﹑·¨….¸;！´？！～—ˉ｜‖＂〃｀@﹫¡¿﹏﹋﹌︴々﹟#﹩$﹠&﹪%*﹡﹢﹦' + '﹤‐￣¯―﹨ˆ˜﹍﹎+=<­＿_-ˇ~﹉﹊（）〈〉‹›﹛﹜『』〖〗［］《》〔〕{}「」【】︵︷︿︹︽_﹁﹃︻︶︸' + '﹀︺︾ˉ﹂﹄︼＋－×÷﹢﹣±／＝≈≡≠∧∨∑∏∪∩∈⊙⌒⊥∥∠∽≌＜＞≤≥≮≯∧∨√﹙﹚[]﹛﹜∫∮∝∞⊙∏' + '┌┬┐┏┳┓╒╤╕─│├┼┤┣╋┫╞╪╡━┃└┴┘┗┻┛╘╧╛┄┆┅┇╭─╮┏━┓╔╦╗┈┊│╳│┃┃╠╬╣┉┋╰─╯┗━┛' + '╚╩╝╲╱┞┟┠┡┢┦┧┨┩┪╉╊┭┮┯┰┱┲┵┶┷┸╇╈┹┺┽┾┿╀╁╂╃╄╅╆' + '○◇□△▽☆●◆■▲▼★♠♥♦♣☼☺◘♀√☻◙♂×▁▂▃▄▅▆▇█⊙◎۞卍卐╱╲▁▏↖↗↑←↔◤◥╲╱▔▕↙↘↓→↕◣◢∷▒░℡™';

_STOPWORD = _STOPWORD.split('');
var STOPWORD = {};
var STOPWORD2 = {};

for (var i in _STOPWORD) {
  if (_STOPWORD[i] === '') continue;
  var len = _STOPWORD[i].length;
  STOPWORD[_STOPWORD[i]] = len;
  if (!STOPWORD2[len]) STOPWORD2[len] = {};
  STOPWORD2[len][_STOPWORD[i]] = len;
}

var PunctuationTokenizer =
/*#__PURE__*/
function (_Tokenizer) {
  (0, _inherits2.default)(PunctuationTokenizer, _Tokenizer);

  function PunctuationTokenizer() {
    (0, _classCallCheck2.default)(this, PunctuationTokenizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(PunctuationTokenizer).apply(this, arguments));
  }

  (0, _createClass2.default)(PunctuationTokenizer, [{
    key: "split",
    value: function split(words) {
      var POSTAG = this.segment.POSTAG;
      var ret = [];

      for (var i = 0, word; word = words[i]; i++) {
        if (word.p > 0) {
          ret.push(word);
          continue;
        } // 仅对未识别的词进行匹配


        var stopinfo = PunctuationTokenizer.matchStopword(word.w);

        if (stopinfo.length < 1) {
          ret.push(word);
          continue;
        } // 分离出标点符号


        var lastc = 0;

        for (var ui = 0, sw; sw = stopinfo[ui]; ui++) {
          if (sw.c > lastc) {
            ret.push({
              w: word.w.substr(lastc, sw.c - lastc)
            });
          } // 忽略空格


          if (sw.w != ' ') {
            ret.push({
              w: sw.w,
              p: POSTAG.D_W
            });
          }

          lastc = sw.c + sw.w.length;
        }

        var lastsw = stopinfo[stopinfo.length - 1];

        if (lastsw.c + lastsw.w.length < word.w.length) {
          ret.push({
            w: word.w.substr(lastsw.c + lastsw.w.length)
          });
        }
      }

      return ret;
    }
    /**
     * 匹配包含的标点符号，返回相关信息
     *
     * @param {string} text 文本
     * @param {int} cur 开始位置
     * @return {array}  返回格式   {w: '网址', c: 开始位置}
     */

  }], [{
    key: "matchStopword",
    value: function matchStopword(text, cur) {
      if (isNaN(cur)) cur = 0;
      var ret = [];
      var isMatch = false;

      while (cur < text.length) {
        for (var _i in STOPWORD2) {
          var w = text.substr(cur, _i);

          if (w in STOPWORD2[_i]) {
            ret.push({
              w: w,
              c: cur
            });
            isMatch = true;
            break;
          }
        }

        cur += isMatch === false ? 1 : w.length;
        isMatch = false;
      }

      return ret;
    }
  }]);
  return PunctuationTokenizer;
}(_BaseModule.Tokenizer);

exports.default = PunctuationTokenizer;