"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

// 单字切分模块
var SingleTokenizer =
/*#__PURE__*/
function (_Tokenizer) {
  (0, _inherits2.default)(SingleTokenizer, _Tokenizer);

  function SingleTokenizer() {
    (0, _classCallCheck2.default)(this, SingleTokenizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(SingleTokenizer).apply(this, arguments));
  }

  (0, _createClass2.default)(SingleTokenizer, [{
    key: "split",
    value: function split(words) {
      var POSTAG = this.segment.POSTAG;
      var ret = [];

      for (var i = 0, word; word = words[i]; i++) {
        if (word.p) {
          ret.push(word);
        } else {
          // 仅对未识别的词进行匹配
          ret = ret.concat(this.splitSingle(word.w));
        }
      }

      return ret;
    }
    /**
     * 单字切分
     *
     * @param {string} text 要切分的文本
     * @param {int} cur 开始位置
     * @return {array}
     */

  }, {
    key: "splitSingle",
    value: function splitSingle(text, cur) {
      var POSTAG = this.segment.POSTAG;
      if (isNaN(cur)) cur = 0;
      var ret = [];

      while (cur < text.length) {
        ret.push({
          w: text.charAt(cur),
          p: POSTAG.UNK
        });
        cur++;
      }

      return ret;
    }
  }]);
  return SingleTokenizer;
}(_BaseModule.Tokenizer);

exports.default = SingleTokenizer;