"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _BaseModule = require("./BaseModule");

// 通配符识别模块
var WildcardTokenizer =
/*#__PURE__*/
function (_Tokenizer) {
  (0, _inherits2.default)(WildcardTokenizer, _Tokenizer);

  function WildcardTokenizer() {
    (0, _classCallCheck2.default)(this, WildcardTokenizer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(WildcardTokenizer).apply(this, arguments));
  }

  (0, _createClass2.default)(WildcardTokenizer, [{
    key: "split",
    value: function split(words) {
      var POSTAG = this.segment.POSTAG;
      var TABLE = this.segment.getDict('WILDCARD');
      var ret = [];

      for (var i = 0, word; word = words[i]; i++) {
        if (word.p > 0) {
          ret.push(word);
          continue;
        } // 仅对未识别的词进行匹配


        var wordinfo = this.matchWord(word.w);

        if (wordinfo.length < 1) {
          ret.push(word);
          continue;
        } // 分离出已识别的单词


        var lastc = 0;

        for (var ui = 0, bw; bw = wordinfo[ui]; ui++) {
          if (bw.c > lastc) {
            ret.push({
              w: word.w.substr(lastc, bw.c - lastc)
            });
          }

          ret.push({
            w: bw.w,
            p: TABLE[bw.w.toLowerCase()].p
          });
          lastc = bw.c + bw.w.length;
        }

        var lastword = wordinfo[wordinfo.length - 1];

        if (lastword.c + lastword.w.length < word.w.length) {
          ret.push({
            w: word.w.substr(lastword.c + lastword.w.length)
          });
        }
      }

      return ret;
    }
    /**
     * 匹配单词，返回相关信息
     *
     * @param {string} text 文本
     * @param {int} cur 开始位置
     * @return {array}  返回格式   {w: '单词', c: 开始位置}
     */

  }, {
    key: "matchWord",
    value: function matchWord(text, cur) {
      if (isNaN(cur)) cur = 0;
      var ret = [];
      var s = false;
      var TABLE = this.segment.getDict('WILDCARD2'); // 匹配可能出现的单词，取长度最大的那个

      var lowertext = text.toLowerCase();

      while (cur < text.length) {
        var stopword = false;

        for (var i in TABLE) {
          if (lowertext.substr(cur, i) in TABLE[i]) {
            stopword = {
              w: text.substr(cur, i),
              c: cur
            };
          }
        }

        if (stopword !== false) {
          ret.push(stopword);
          cur += stopword.w.length;
        } else {
          cur++;
        }
      }

      return ret;
    }
  }]);
  return WildcardTokenizer;
}(_BaseModule.Tokenizer);

exports.default = WildcardTokenizer;