"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "AdjectiveOptimizer", {
  enumerable: true,
  get: function get() {
    return _AdjectiveOptimizer.default;
  }
});
Object.defineProperty(exports, "CHS_NAMES", {
  enumerable: true,
  get: function get() {
    return _CHS_NAMES.default;
  }
});
Object.defineProperty(exports, "ChsNameTokenizer", {
  enumerable: true,
  get: function get() {
    return _ChsNameTokenizer.default;
  }
});
Object.defineProperty(exports, "DictOptimizer", {
  enumerable: true,
  get: function get() {
    return _DictOptimizer.default;
  }
});
Object.defineProperty(exports, "EmailOptimizer", {
  enumerable: true,
  get: function get() {
    return _EmailOptimizer.default;
  }
});
Object.defineProperty(exports, "PunctuationTokenizer", {
  enumerable: true,
  get: function get() {
    return _PunctuationTokenizer.default;
  }
});
Object.defineProperty(exports, "URLTokenizer", {
  enumerable: true,
  get: function get() {
    return _URLTokenizer.default;
  }
});
Object.defineProperty(exports, "ChsNameOptimizer", {
  enumerable: true,
  get: function get() {
    return _ChsNameOptimizer.default;
  }
});
Object.defineProperty(exports, "DatetimeOptimizer", {
  enumerable: true,
  get: function get() {
    return _DatetimeOptimizer.default;
  }
});
Object.defineProperty(exports, "DictTokenizer", {
  enumerable: true,
  get: function get() {
    return _DictTokenizer.default;
  }
});
Object.defineProperty(exports, "ForeignTokenizer", {
  enumerable: true,
  get: function get() {
    return _ForeignTokenizer.default;
  }
});
Object.defineProperty(exports, "SingleTokenizer", {
  enumerable: true,
  get: function get() {
    return _SingleTokenizer.default;
  }
});
Object.defineProperty(exports, "WildcardTokenizer", {
  enumerable: true,
  get: function get() {
    return _WildcardTokenizer.default;
  }
});
Object.defineProperty(exports, "Module", {
  enumerable: true,
  get: function get() {
    return _BaseModule.Module;
  }
});
Object.defineProperty(exports, "Tokenizer", {
  enumerable: true,
  get: function get() {
    return _BaseModule.Tokenizer;
  }
});
Object.defineProperty(exports, "Optimizer", {
  enumerable: true,
  get: function get() {
    return _BaseModule.Optimizer;
  }
});
exports.modules = void 0;

var _AdjectiveOptimizer = _interopRequireDefault(require("./AdjectiveOptimizer"));

var _CHS_NAMES = _interopRequireDefault(require("./CHS_NAMES"));

var _ChsNameTokenizer = _interopRequireDefault(require("./ChsNameTokenizer"));

var _DictOptimizer = _interopRequireDefault(require("./DictOptimizer"));

var _EmailOptimizer = _interopRequireDefault(require("./EmailOptimizer"));

var _PunctuationTokenizer = _interopRequireDefault(require("./PunctuationTokenizer"));

var _URLTokenizer = _interopRequireDefault(require("./URLTokenizer"));

var _ChsNameOptimizer = _interopRequireDefault(require("./ChsNameOptimizer"));

var _DatetimeOptimizer = _interopRequireDefault(require("./DatetimeOptimizer"));

var _DictTokenizer = _interopRequireDefault(require("./DictTokenizer"));

var _ForeignTokenizer = _interopRequireDefault(require("./ForeignTokenizer"));

var _SingleTokenizer = _interopRequireDefault(require("./SingleTokenizer"));

var _WildcardTokenizer = _interopRequireDefault(require("./WildcardTokenizer"));

var _BaseModule = require("./BaseModule");

var modules = [// 强制分割类单词识别
_URLTokenizer.default, // URL识别
_WildcardTokenizer.default, // 通配符，必须在标点符号识别之前
_PunctuationTokenizer.default, // 标点符号识别
_ForeignTokenizer.default, // 外文字符、数字识别，必须在标点符号识别之后
// 中文单词识别
_DictTokenizer.default, // 词典识别
_ChsNameTokenizer.default, // 人名识别，建议在词典识别之后
// 优化模块
_EmailOptimizer.default, // 邮箱地址识别
_ChsNameOptimizer.default, // 人名识别优化
_DictOptimizer.default, // 词典识别优化
_DatetimeOptimizer.default, // 日期时间识别优化
_AdjectiveOptimizer.default];
exports.modules = modules;